VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} FormModelTweaker 
   Caption         =   "Model Tweaker"
   ClientHeight    =   3510
   ClientLeft      =   45
   ClientTop       =   360
   ClientWidth     =   7350
   OleObjectBlob   =   "FormModelTweaker.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "FormModelTweaker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'--------------------------------------------------------------------04/22/2004
' ModelTweaker.swp - Copyright 2004 Leonard Kikstra
'------------------------------------------------------------------------------
' Notes: Source file must be in same directory as macro file.
'        Source file must have same name as macro file with '.ini' extension.
'------------------------------------------------------------------------------
' Revision History
'        1.0 - Initial creation
'------------------------------------------------------------------------------
Dim Source As String
Dim SpinButton(8) As Object
Dim SpinLabel(8) As Object
Dim SpinDLButton(8) As Object
Dim SpinDLLabel(8) As Object
Dim DLName As String
Dim DLAmbi As Double
Dim DLDiff As Double
Dim DLSpec As Double
Dim DLColor As Long
Dim DLEnabled As Boolean
Dim DLFixed As Boolean
Dim DLxDir As Double
Dim DLyDir As Double
Dim DLzDir As Double
Dim Resolution As Integer
Dim ColorResol As Integer
Const Version = "1.0"
Dim AngleRes As Double
                    
Private Sub ReadSource()
' StatPart "Reading materials list.", 0
  Open Source For Input As #1                          ' Open source file.
  Do While Not EOF(1)                                  ' Loop until end of file.
    Input #1, Reader                                   ' Read data line.
    If Reader = "[SETTING]" Then
      Do While Not EOF(1)                              ' Loop until end of file.
        Input #1, Setting                              ' Read data line.
        If UCase(Left$(Setting, 10)) = UCase("Resolution") Then
          Resolution = Mid$(Setting, 12)
        ElseIf UCase(Left$(Setting, 10)) = UCase("ColorResol") Then
          ColorResol = Mid$(Setting, 12)
        Else
          GoTo EndSettingRead
        End If
      Loop
EndSettingRead:
    ElseIf Reader = "[PRESETS-COLORS]" Then            ' Looking for section.
      Do While Not EOF(1)                              ' Loop until end of file.
        Input #1, ColorVal                             ' Read data line.
        If ColorVal <> "" Then                         ' Is name valid?
          Input #1, ColorName
          AddColor ColorName, ColorVal
        Else
          GoTo EndColorRead
        End If
      Loop
EndColorRead:
    ElseIf Reader = "[PRESETS-PROPERTIES]" Then        ' Looking for section.
      Do While Not EOF(1)                              ' Loop until end of file.
        Input #1, Profile                              ' Read data line.
        If Profile <> "" Then                          ' Is name valid?
          Input #1, Ambi, Diff, Spec, Shin, Tran, Emis
          AddProfile Profile, Ambi, Diff, Spec, Shin, Tran, Emis
        Else
          GoTo EndPropRead
        End If
      Loop
EndPropRead:
    ElseIf Reader = "[LIGHT-DIRECTIONAL]" Then
      Do While Not EOF(1)                              ' Loop until end of file.
        Input #1, Profile                              ' Read data line.
        If Profile <> "" Then                          ' Is name valid?
          Input #1, Bright, Specular, xDir, yDir, zDir
          AddDirectional Profile, Bright, Specular, xDir, yDir, zDir
        Else
          GoTo EndDirectRead
        End If
      Loop
EndDirectRead:
    End If
  Loop
  Close #1    ' Close file.
End Sub

Private Sub AddColor(ColorNam, ColorVal)
  ComboBoxColor.AddItem ColorNam
  ComboBoxColor.List(ComboBoxColor.ListCount - 1, 1) = ColorVal
End Sub

Private Sub ComboBoxColor_Change()
  If ComboBoxColor.ListIndex >= 0 Then
    MyColor = Right$("000000" + Hex(ComboBoxColor.List(ComboBoxColor.ListIndex, 1)), 6)
    SpinButton(0) = Val("&H" + Mid(MyColor, 1, 2)) / 255 * ColorResol ' Red Value
    SpinButton(1) = Val("&H" + Mid(MyColor, 3, 2)) / 255 * ColorResol ' Green Value
    SpinButton(2) = Val("&H" + Mid(MyColor, 5, 2)) / 255 * ColorResol ' Blue Value
  End If
  ComboBoxColor.ListIndex = -1
End Sub

Private Sub AddProfile(Profile, Ambi, Diff, Spec, Shin, Tran, Emis)
  ComboBoxProfiles.AddItem Profile
  ComboBoxProfiles.List(ComboBoxProfiles.ListCount - 1, 1) = Ambi   ' Ambient
  ComboBoxProfiles.List(ComboBoxProfiles.ListCount - 1, 2) = Diff   ' Diffusion
  ComboBoxProfiles.List(ComboBoxProfiles.ListCount - 1, 3) = Spec   ' Specularity
  ComboBoxProfiles.List(ComboBoxProfiles.ListCount - 1, 4) = Shin   ' Shininess
  ComboBoxProfiles.List(ComboBoxProfiles.ListCount - 1, 5) = Tran   ' Transparency
  ComboBoxProfiles.List(ComboBoxProfiles.ListCount - 1, 6) = Emis   ' Emission
End Sub

Private Sub ComboBoxProfiles_Change()
  If ComboBoxProfiles.ListIndex >= 0 Then
    For x = 3 To 8
      SpinButton(x) = ComboBoxProfiles.List(ComboBoxProfiles.ListIndex, x - 2) * Resolution
    Next x
  End If
  ComboBoxProfiles.ListIndex = -1
End Sub

Private Sub DynProp()
  RetVar = ModelDoc2.MaterialPropertyValues            ' Read props from model
  For x = 0 To 2
    RetVar(x) = SpinButton(x) / ColorResol
    SpinLabel(x) = " " & RetVar(x) * 256
  Next x
  For x = 3 To 8
    RetVar(x) = SpinButton(x) / Resolution
    SpinLabel(x) = " " & RetVar(x)
  Next x
  ModelDoc2.MaterialPropertyValues = RetVar            ' Write props to model
  ModelDoc2.GraphicsRedraw
End Sub

Private Sub AddDirectional(Profile, Bright, Specul, xDir, yDir, zDir)
  ComboBoxDLScheme.AddItem Profile
  ComboBoxDLScheme.List(ComboBoxDLScheme.ListCount - 1, 1) = Bright ' Ambient
  ComboBoxDLScheme.List(ComboBoxDLScheme.ListCount - 1, 2) = Specul ' Specularity
  ComboBoxDLScheme.List(ComboBoxDLScheme.ListCount - 1, 3) = xDir   ' Horizontal
  ComboBoxDLScheme.List(ComboBoxDLScheme.ListCount - 1, 4) = yDir   ' Vertical
  ComboBoxDLScheme.List(ComboBoxDLScheme.ListCount - 1, 5) = zDir   ' Depth
End Sub

Private Sub ComboBoxDLScheme_Change()
  If ComboBoxDLScheme.ListIndex >= 0 Then
    For x = 0 To 4
      SpinDLButton(x) = ComboBoxDLScheme.List(ComboBoxDLScheme.ListIndex, x + 1) * Resolution
    Next x
  End If
  ComboBoxDLScheme.ListIndex = -1
End Sub

Private Sub DynDirectional()
  retval = ModelDoc2.GetDirectionLightProperties(DLName, DLAmbi, DLDiff, DLSpec, _
                    DLColor, DLEnabled, DLFixed, DLxDir, DLyDir, DLzDir)
  ' name, ambient, diffuse, specular, color, enabled, fixed, xDir, yDir, zDir
  DLAmbi = SpinDLButton(0) / Resolution                ' 0 = Ambient
  DLSpec = SpinDLButton(1) / Resolution                ' 1 = Specularity
  DLxDir = SpinDLButton(2) / Resolution                ' 2 = Horizontal
  DLyDir = SpinDLButton(3) / Resolution                ' 3 = Vertical
  DLzDir = SpinDLButton(4) / Resolution                ' 3 = Vertical
  For x = 0 To 4
    SpinDLLabel(x) = " " & SpinDLButton(x) / Resolution
  Next x
  retval = ModelDoc2.SetDirectionLightProperties(DLName, DLAmbi, DLDiff, DLSpec, _
                    DLColor, DLEnabled, DLFixed, DLxDir, DLyDir, DLzDir)
  ModelDoc2.GraphicsRedraw
End Sub

Private Sub SpinButtonDLBrightness_Change()
  DynDirectional
End Sub
Private Sub SpinButtonDLSpecularity_Change()
  DynDirectional
End Sub
Private Sub SpinButtonDLHorizontal_Change()
  DynDirectional
End Sub
Private Sub SpinButtonDLVertical_Change()
  DynDirectional
End Sub
Private Sub SpinButtonDLDepth_Change()
  DynDirectional
End Sub

Private Sub SpinButtonRed_Change()
  DynProp
End Sub
Private Sub SpinButtonGreen_Change()
  DynProp
End Sub
Private Sub SpinButtonBlue_Change()
  DynProp
End Sub
Private Sub SpinButtonAmbient_Change()
  DynProp
End Sub
Private Sub SpinButtonDiffuse_Change()
  DynProp
End Sub
Private Sub SpinButtonEmission_Change()
  DynProp
End Sub
Private Sub SpinButtonShininess_Change()
  DynProp
End Sub
Private Sub SpinButtonSpecularity_Change()
  DynProp
End Sub
Private Sub SpinButtonTransparency_Change()
  DynProp
End Sub

Private Sub CommandClose_Click()
  End
End Sub

Private Sub UserForm_Initialize()
  FormModelTweaker.Caption = FormModelTweaker.Caption + " " + Version
  AngleRes = Round(Atn(1), 3)
  Resolution = 10
  
  LSCount = ModelDoc2.GetLightSourceCount()
  For x = 0 To LSCount - 1
    DLName = ModelDoc2.GetLightSourceName(x)
    Temp = Left$(DLName, 11)
    If Left$(DLName, 9) = "Direction" Then
      ComboBoxDirectional.AddItem DLName
    End If
  Next x
  
  ComboBoxColor.Clear
  ComboBoxProfiles.Clear
  RetVar = ModelDoc2.MaterialPropertyValues       ' Read props from model
  ' Red, Green, Blue, Ambient, Diffuse, Specular, Shininess, Transparency, Emission
  AddColor "(Current)", RGB(RetVar(2) * 256, RetVar(1) * 256, RetVar(0) * 256)
  AddProfile "(Current)", RetVar(3), RetVar(4), RetVar(5), RetVar(6), RetVar(7), RetVar(8)
  
  ComboBoxDirectional.ListIndex = 0
  retval = ModelDoc2.GetDirectionLightProperties(ComboBoxDirectional.Value, _
                    DLAmbi, DLDiff, DLSpec, DLColor, DLEnabled, _
                    DLFixed, DLxDir, DLyDir, DLzDir)
  ' name, ambient, diffuse, specular, color, enabled, fixed, xDir, yDir, zDir
  AddDirectional "(Current)", DLAmbi, DLSpec, Round(DLxDir, 3), Round(DLyDir, 3), Round(DLzDir, 3)
  
  Source = swApp.GetCurrentMacroPathName               ' Get macro path+filename
  Source = Left$(Source, Len(Source) - 3) + "ini"      ' Set source filename
  Set FileSys = CreateObject("Scripting.FileSystemObject")
  If FileSys.FileExists(Source) Then                   ' Does source file exist?
    ReadSource
  End If
  
  Set SpinButton(0) = SpinButtonRed
  Set SpinButton(1) = SpinButtonGreen
  Set SpinButton(2) = SpinButtonBlue
  Set SpinButton(3) = SpinButtonAmbient
  Set SpinButton(4) = SpinButtonDiffuse
  Set SpinButton(5) = SpinButtonSpecularity
  Set SpinButton(6) = SpinButtonShininess
  Set SpinButton(7) = SpinButtonTransparency
  Set SpinButton(8) = SpinButtonEmission

  Set SpinLabel(0) = LabelRed
  Set SpinLabel(1) = LabelGreen
  Set SpinLabel(2) = LabelBlue
  Set SpinLabel(3) = LabelAmbient
  Set SpinLabel(4) = LabelDiffuse
  Set SpinLabel(5) = LabelSpecularity
  Set SpinLabel(6) = LabelShininess
  Set SpinLabel(7) = LabelTransparency
  Set SpinLabel(8) = LabelEmission

  SpinButtonRed.Max = ColorResol
  SpinButtonGreen.Max = ColorResol
  SpinButtonBlue.Max = ColorResol
  SpinButtonAmbient.Max = Resolution
  SpinButtonDiffuse.Max = Resolution
  SpinButtonSpecularity.Max = Resolution
  SpinButtonShininess.Max = Resolution
  SpinButtonTransparency.Max = Resolution
  SpinButtonEmission.Max = Resolution

  Set SpinDLButton(0) = SpinButtonDLBrightness
  Set SpinDLButton(1) = SpinButtonDLSpecularity
  Set SpinDLButton(2) = SpinButtonDLHorizontal
  Set SpinDLButton(3) = SpinButtonDLVertical
  Set SpinDLButton(4) = SpinButtonDLDepth
  
  Set SpinDLLabel(0) = LabelDLBrightness
  Set SpinDLLabel(1) = LabelDLSpecularity
  Set SpinDLLabel(2) = LabelDLHorizontal
  Set SpinDLLabel(3) = LabelDLVertical
  Set SpinDLLabel(4) = LabelDLDepth
  
  SpinButtonDLBrightness.Max = Resolution
  SpinButtonDLSpecularity.Max = Resolution
  SpinButtonDLHorizontal.Max = Resolution * 3
  SpinButtonDLHorizontal.Min = 1 - Resolution * 3
  SpinButtonDLVertical.Max = Resolution * 3
  SpinButtonDLVertical.Min = 1 - Resolution * 3
  SpinButtonDLDepth.Max = Resolution * 3
  SpinButtonDLDepth.Min = 1 - Resolution * 3

' For x = 0 To 3
'   SpinButton(x) = RetVar(x) * Resolution
' Next x
  ComboBoxColor.ListIndex = 0
  ModelDoc2.GraphicsRedraw
  ComboBoxProfiles.ListIndex = 0
  ModelDoc2.GraphicsRedraw
  ComboBoxDLScheme.ListIndex = 0
  ModelDoc2.GraphicsRedraw
  
End Sub

